--the mans data like position
man = { }
man.x = 200
man.y = 200
man.w = 40
man.h = 40
man.ax = 0 --velocity, I call them ax and ay
man.ay = 0

--an empty table for all objects
objects = { }

--lets create a function to 'spawn' objekts, its easier.
function spawnObject(x, y, w, h, ax, ay)
	local o = { }
	o.x = x
	o.y = y
	o.w = w
	o.h = h
	o.ax = ax --velocity
	o.ay = ay
	objects[#objects+1] = o
end

--spawn 2 objects
spawnObject(10, 10, 70, 30, 10, 10)
spawnObject(700, 500, 20, 25, -5, -8)

--our collidion function
function collision(x1, y1, w1, h1, x2, y2, w2, h2)
	if x1 + w1 > x2
	and x1 < x2 + w2
	and y1 + h1 > y2
	and y1 < y2 + h2 then
		return true
	else
		return false
	end
end

--mapcolliding
function mapCollision(x, y, w, h)
	if x < 0 or y < 0 or x+w > 800 or y+h > 600 then
		return true
	else
		return false
	end
end

function love.draw()
	--draws all objects
	love.graphics.setColor(255, 255, 255)
	for i, o in ipairs(objects) do
		love.graphics.rectangle("line", o.x, o.y, o.w, o.h)
	end
	
	--draws you, in red
	love.graphics.setColor(255, 0, 0)
	love.graphics.rectangle("line", man.x, man.y, man.w, man.h)
end

function love.update(dt)
	
	--only to control the game speed
	dt = dt * 5
	
	for i, o in ipairs(objects) do
		
		o.x = o.x + o.ax * dt
		if collision(o.x, o.y, o.w, o.h, man.x, man.y, man.w, man.h) then --pushes you
			--I could write 'man.x = man.x + o.ax', but that will make small optic errors
			if o.ax > 0 then --pushing you to the right side
				man.x = o.x + o.w
			else
				man.x = o.x - man.w
			end
		end
		if mapCollision(o.x, o.y, o.w, o.h) then --return
			o.x = o.x - o.ax * dt
			o.ax = - o.ax
		end
		
		o.y = o.y + o.ay * dt
		if collision(o.x, o.y, o.w, o.h, man.x, man.y, man.w, man.h) then --pushes you
			--Again: I could write 'man.y = man.y + o.ay', but that will make small optic errors
			if o.ay > 0 then --pushing you to the right side
				man.y = o.y + o.h
			else
				man.y = o.y - man.h
			end
		end
		if mapCollision(o.x, o.y, o.w, o.h) then --return
			o.y = o.y - o.ay * dt
			o.ay = - o.ay
		end
		
	end
	
	if love.keyboard.isDown("left") and not love.keyboard.isDown("right") then
		man.ax = man.ax - 20 * dt
	elseif love.keyboard.isDown("right") and not love.keyboard.isDown("left") then
		man.ax = man.ax + 20 * dt
	else
		if man.ax > 0 then
			man.ax = man.ax - 5 * dt
			if man.ax < 0 then
				man.ax = 0
			end
		else
			man.ax = man.ax + 5 * dt
			if man.ax > 0 then
				man.ax = 0
			end
		end
	end
	local oldX = man.x --backups the old position
	man.x = man.x + man.ax * dt
	for i, o in ipairs(objects) do
		if collision(o.x, o.y, o.w, o.h, man.x, man.y, man.w, man.h) then
			man.x = oldX
		end
	end
	if mapCollision(man.x, man.y, man.w, man.h) then
		man.x = oldX
		man.ax = -man.ax/2
	end
	
	if love.keyboard.isDown("up") and not love.keyboard.isDown("down") then
		man.ay = man.ay - 20 * dt
	elseif love.keyboard.isDown("down") and not love.keyboard.isDown("up") then
		man.ay = man.ay + 20 * dt
	else
		if man.ay > 0 then
			man.ay = man.ay - 5 * dt
			if man.ay < 0 then
				man.ay = 0
			end
		else
			man.ay = man.ay + 5 * dt
			if man.ay > 0 then
				man.ay = 0
			end
		end
	end
	local oldY = man.y --backups the old position
	man.y = man.y + man.ay * dt
	for i, o in ipairs(objects) do
		if collision(o.x, o.y, o.w, o.h, man.x, man.y, man.w, man.h) then
			man.y = oldY
		end
	end
	if mapCollision(man.x, man.y, man.w, man.h) then
		man.y = oldY
		man.ay = -man.ay/2
	end
	
	if man.x < 0 then man.x = 0 end
	if man.y < 0 then man.y = 0 end
	if man.x + man.w > 800 then man.x = 800 - man.w end
	if man.y + man.h > 600 then man.y = 600 - man.h end
end